"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createEmotionSsrAdvancedApproach = void 0;
const React = __importStar(require("react"));
const create_instance_1 = __importDefault(require("@emotion/server/create-instance"));
const react_1 = require("@emotion/react");
const cache_1 = __importDefault(require("@emotion/cache"));
const document_1 = __importDefault(require("next/document"));
/** @see <https://docs.tss-react.dev/ssr/next> */
function createEmotionSsrAdvancedApproach(options, CacheProvider = react_1.CacheProvider) {
    let cache = undefined;
    const createSpecificCacheCache = () => (cache = (0, cache_1.default)(options));
    function augmentDocumentWithEmotionCache(Document) {
        var _a, _b;
        const super_getInitialProps = (_b = (_a = Document.getInitialProps) === null || _a === void 0 ? void 0 : _a.bind(Document)) !== null && _b !== void 0 ? _b : document_1.default.getInitialProps.bind(document_1.default);
        Document.getInitialProps = (appContext) => __awaiter(this, void 0, void 0, function* () {
            const cache = createSpecificCacheCache();
            const emotionServer = (0, create_instance_1.default)(cache);
            const initialProps = yield super_getInitialProps(appContext);
            const emotionStyles = emotionServer
                .extractCriticalToChunks(initialProps.html)
                .styles.filter(({ css }) => css !== "")
                .map(style => (React.createElement("style", { "data-emotion": `${style.key} ${style.ids.join(" ")}`, key: style.key, dangerouslySetInnerHTML: { "__html": style.css } })));
            const otherStyles = React.Children.toArray(initialProps.styles);
            return Object.assign(Object.assign({}, initialProps), { "styles": !!cache.sheet.prepend
                    ? [...emotionStyles, ...otherStyles]
                    : [...otherStyles, ...emotionStyles] });
        });
    }
    function withAppEmotionCache(App) {
        function AppWithEmotionCache(props) {
            return (React.createElement(CacheProvider, { value: cache !== null && cache !== void 0 ? cache : createSpecificCacheCache() },
                React.createElement(App, Object.assign({}, props))));
        }
        Object.keys(App).forEach(staticMethod => (AppWithEmotionCache[staticMethod] = App[staticMethod]));
        AppWithEmotionCache.displayName = AppWithEmotionCache.name;
        return AppWithEmotionCache;
    }
    return { withAppEmotionCache, augmentDocumentWithEmotionCache };
}
exports.createEmotionSsrAdvancedApproach = createEmotionSsrAdvancedApproach;
